/**
 *  PCondition.cc
 */

#include "PCondition.h"
#include <errno.h>

namespace PThreadNS {

PCondition::PCondition(PMutex &pMutex)
  : _pMutex(pMutex)
{
  pthread_cond_init(&_cond, 0);
}

PCondition::PCondition(PMutex *pMutex)
  : _pMutex(*pMutex)
{
  pthread_cond_init(&_cond, 0);
}

PCondition::~PCondition()
{

}

void PCondition::wait()
{
  pthread_cond_wait(&_cond, &_pMutex._mutex);
}

void PCondition::signal()
{
  pthread_cond_signal(&_cond);
}

} // namespace PThreadNS
