/**
 *  PCondition.h
 */

#ifndef BS1_PCONDITION_H
#define BS1_PCONDITION_H

#include "PMutex.h"
#include <pthread.h>

namespace PThreadNS {

class PCondition
{
public:
  // Exceptions
  class Error { };

  PCondition(PMutex &pMutex);
  PCondition(PMutex *pMutex);
  ~PCondition();

  void wait();
  void signal();

private:
  PMutex &_pMutex;
  pthread_cond_t _cond;
};

} // namespace PThreadNS

#endif // BS1_PCONDITION_H
