/**
 *  PMutex.cc
 */

#include "PMutex.h"
#include <errno.h>

namespace PThreadNS {

PMutex::PMutex()
{
  pthread_mutex_init(&_mutex, 0);
}

PMutex::~PMutex()
{
  pthread_mutex_destroy(&_mutex);
}

void PMutex::lock()
{
  pthread_mutex_lock(&_mutex);
}

bool PMutex::trylock()
{
  int err = pthread_mutex_trylock(&_mutex);

  if (err == EBUSY)
    return false;

  if (err)
    throw Error();

  return true;
}

void PMutex::unlock()
{
  pthread_mutex_unlock(&_mutex);
}

} // namespace PThreadNS
