/**
 *  Mutex.h
 */


#ifndef BS1_MUTEX_H
#define BS1_MUTEX_H

#include <pthread.h>

namespace PThreadNS {

class PCondition;

class PMutex
{
  friend class PCondition;

public:
  // Exceptions
  class Error { };

  PMutex();
  ~PMutex();

  void lock();
  bool trylock();
  void unlock();

private:
  pthread_mutex_t _mutex;
};

} // namespace PThreadNS

#endif // BS1_MUTEX_H
