/**
 *  PThread.h
 */

#ifndef BS1_PTHREAD_H
#define BS1_PTHREAD_H

#include <pthread.h>

namespace PThreadNS {

class PThread
{
public:
  // Exceptions
  class NotImplemented { };

  PThread();
  virtual ~PThread();

  virtual void start();
  virtual void stop();
  virtual void suspend();
  virtual void resume();
  virtual void join();

  virtual void run() = 0;

private:
  static void *run_wrapper(void *);

  pthread_t _thread;
};

} // namespace PThreadNS

#endif // BS1_PTHREAD_H
