#include <unistd.h>
#include <cstdio>

using namespace std;

class ErrnoError { };

char *schreiber_args[] =
  { "./schreiber", "prim-ausgabe.txt", 0 };

char *leser_args[] =
  { "./leser", "prim-eingabe.txt", 0 };

char *zerleger_args[] =
  { "./zerleger", 0 };

int main()
{
  try {
    int zerlger_schreiber_pipe[2];
    const int &schreiber_stdin_fd = zerlger_schreiber_pipe[0];
    const int &zerleger_stdout_fd = zerlger_schreiber_pipe[1];

    if (pipe(zerlger_schreiber_pipe))
      throw ErrnoError();

    if (!vfork())
    {
      if (close(schreiber_stdin_fd))
        throw ErrnoError();

      int leser_zerlger_pipe[2];
      const int &zerleger_stdin_fd = leser_zerlger_pipe[0];
      const int &leser_stdout_fd = leser_zerlger_pipe[1];

      if (pipe(leser_zerlger_pipe))
        throw ErrnoError();

      if (!vfork())
      {
        if (close(zerleger_stdin_fd))
          throw ErrnoError();

        if (dup2(leser_stdout_fd, STDOUT_FILENO) == -1)
          throw ErrnoError();

        execvp(leser_args[0], leser_args);
        throw ErrnoError();
      }
      else
      {
        if (close(leser_stdout_fd))
          throw ErrnoError();

        if (dup2(zerleger_stdout_fd, STDOUT_FILENO) == -1)
          throw ErrnoError();

        if (dup2(zerleger_stdin_fd, STDIN_FILENO) == -1)
          throw ErrnoError();

        execvp(zerleger_args[0], zerleger_args);
        throw ErrnoError();
      }
    }
    else
    {
      if (close(zerleger_stdout_fd))
        throw ErrnoError();

      if (dup2(schreiber_stdin_fd, STDIN_FILENO) == -1)
        throw ErrnoError();

      execvp(schreiber_args[0], schreiber_args);
      throw ErrnoError();
    }
  }
  catch(ErrnoError) {
    perror("Pgm");
    return 1;
  }
}