#include <unistd.h>
#include <cstdio>

using namespace std;

class ErrnoError { };

char *schreiber_args[] =
  { "./schreiber", "outfile", 0 };

char *leser_args[] =
  { "./leser", "index.html", 0 };

int main()
{
  int filedes[2];
  const int &read_fd = filedes[0];
  const int &write_fd = filedes[1];

  try {
    if (pipe(filedes))
      throw ErrnoError();

    if (!vfork())
    {
      if (close(read_fd))
        throw ErrnoError();

      if (dup2(write_fd, STDOUT_FILENO) == -1)
        throw ErrnoError();

      execvp(leser_args[0], leser_args);
      throw ErrnoError();
    }
    else
    {
      if (close(write_fd))
        throw ErrnoError();

      if (dup2(read_fd, STDIN_FILENO) == -1)
        throw ErrnoError();

      execvp(schreiber_args[0], schreiber_args);
      throw ErrnoError();
    }
  }
  catch(...) {
    perror("Pm");
    return 1;
  }
}