/**
 *  Database.cc
 */

#include "Database.h"
#include <unistd.h>
#include <stdlib.h>
#include <iostream>

using namespace std;

int Database::NAP_TIME = 15;

Database::Database()
  : readerCount(0)
  , mutex(1)
  , db(1)
{

}

void Database::napping()
{
  int sleeptime = (NAP_TIME * rand()) % 20;
  sleep (sleeptime);
}

int Database::startRead()
{
  mutex.P();
  ++readerCount;

  // wenn ich der erste Leser bin, sage den anderen,
  // dass die Datenbasis gelesen wird
  if (readerCount == 1)
    db.P();

  mutex.V();
  return readerCount;
}

int Database::endRead()
{
  mutex.P();
  --readerCount;

  // wenn ich der letzte Leser bin, sage den anderen,
  // dass die Datenbasis nicht mehr gelesen wird
  if (readerCount == 0)
    db.V();

  mutex.V();
  return readerCount;
}

void Database::startWrite()
{
  db.P();
}

void Database::endWrite()
{
  db.V();
}
