#ifndef ADDRESS_SPACE_H_
#define ADDRESS_SPACE_H_

#include "pagingInt.h"

namespace PagingNS {

class AddressSpace
{
public:
  /** constructor */
  AddressSpace()
    : pageTable(vm.aquire()) { }

  /** destructor */
  ~AddressSpace()
  {
    vm.release(pageTable);
  }

  /**
   *  gibt eine Referenz auf das Byte an der _logischen_ Adresse pos zurck
   */
  Byte &getByteAt(LogicalAddress pos)
  {
    toLittleEndian(pos);
    Byte pageNr     = (reinterpret_cast<Byte *>(&pos))[0];
    Byte pageOffset = (reinterpret_cast<Byte *>(&pos))[1];
    return pageTable[pageNr].fetch(pageOffset);
  }

  /**  */
  static const int SIZE;

private:
  /**
   *  Feld mit PAGE_COUNT Elementen (jeder Adressraum hat seine Seiten-Tabelle)
   */
  VirtualPage * const pageTable;

  /**  */
  static VirtualMemory & vm;
};

}

#endif
