/* PagingInt.h
   interne Definitionen des Paging Moduls
*/

#ifndef PAGING_INT_H_
#define PAGING_INT_H_

#include "paging.h"

// Privater Teil des Namensraums OS_NS
//
namespace PagingNS {

  const unsigned int FRAME_SIZE  =     0x100;        // Rahmengroesse
  const unsigned int FRAME_COUNT =        50;        // Zahl der Rahmen im Hauptspeicher
  
  const unsigned int PAGE_COUNT  =     0x100;        // Zahl der Seiten pro Adressraum (1 Byte Seitenadresse )
  const unsigned int PAGE_SIZE   = FRAME_SIZE;
  
  const unsigned int SLOT_SIZE  =  FRAME_SIZE;       // Groesse der Slots im SwapSpace
  const unsigned int SLOT_COUNT =       0x100;       // Zahl der Slots im SwapSpace
  
  const unsigned int MAX_PROCESS_COUNT = 10;         // maximale Zahl der aktiven Prozesse (= Zahl der moeglichen Seitentabellen)

  const unsigned int LIMIT_LOW  = 0;                 // Zahl der freien Rahmen, ab der der Speicher als voll gilt

  void byteSwap( Word &w );
  bool isSysBigEndian();
  void toLittleEndian( Word &w );
}

#endif
